# coding: utf-8

"""
    Redis Enterprise API

    REST API Specifications[¶](#rest-api-specifications \"Permalink to this headline\") =================================================================================  Key Concepts[¶](#key-concepts \"Permalink to this headline\") -----------------------------------------------------------  ### Clusters[¶](#clusters \"Permalink to this headline\")  Redis Labs clusters are a set of nodes, typically two or more, providing database services. Clusters are inherently multi-tenant, and a single cluster can manage multiple databases accessed through individual endpoints.  Protocol and Headers[¶](#protocol-and-headers \"Permalink to this headline\") ---------------------------------------------------------------------------  ### JSON Requests and Responses[¶](#json-requests-and-responses \"Permalink to this headline\")  The Redis Labs REST API uses the JavaScript Object Notation (JSON) for requests and responses.  Some responses may have an empty body, but indicate the response with standard HTTP codes. For more information, see RFC 4627 ([http://www.ietf.org/rfc/rfc4627.txt](http://www.ietf.org/rfc/rfc4627.txt)) and www.json.org.  Both requests and responses may include zero or more objects.  In case the request is for a single entity, the response shall return a single JSON object, or none. In case the request if for a list of entities, the response shall return a single JSON array with 0 or more elements.  Requests may be delivered with some JSON object fields missing. In this case, these fields will be assigned default values (often indicating they are not in use).  ### Request Headers[¶](#request-headers \"Permalink to this headline\")  The Redis Labs REST API supports the following HTTP headers:  | Header | Supported/Required Values | |---|---| | Accept | application/json | | Content-Length | Length (in bytes) of request message. | | Content-Type | application/json |   ### Response Headers[¶](#response-headers \"Permalink to this headline\")  The Redis Labs REST API supports the following HTTP headers:  | Header | Supported/Required Values | |---|---| | Content-Type | application/json | | Content-Length | Length (in bytes) of request message. |   API Versions[¶](#api-versions \"Permalink to this headline\") -----------------------------------------------------------  All RLEC API operations are versioned, in order to minimize the impact of backwards-incompatible API changes and to coordinate between different versions operating in parallel.  Authentication[¶](#authentication \"Permalink to this headline\") ---------------------------------------------------------------  Authentication to RLEC API occurs via [Basic Auth](https://en.wikipedia.org/wiki/Basic_access_authentication). Provide your RLEC username and password as the basic auth credentials.  All calls must be made over SSL, to port 9443.  Example Request:  ```bash curl \\-u \"demo@redislabs.com:password\" https://localhost:9443/v1/bdbs ```  Common Responses[¶](#common-responses \"Permalink to this headline\") -------------------------------------------------------------------  The following are common responses which may be returned in some cases regardless of any specific request.  | Response | Condition / Required handling | |---|---| | 503 (Service Unavailable) | Contacted node is currently not a member of any active cluster. | | 505 (HTTP Version Not Supported) | An unsupported X-API-Version was used, see API Versions above. |   # noqa: E501

    OpenAPI spec version: 6.2.4-55
    Contact: matthew.royal@redis.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class BdbModuleList(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'module_args': 'str',
        'module_id': 'str',
        'module_name': 'str',
        'semantic_version': 'str'
    }

    attribute_map = {
        'module_args': 'module_args',
        'module_id': 'module_id',
        'module_name': 'module_name',
        'semantic_version': 'semantic_version'
    }

    def __init__(self, module_args=None, module_id=None, module_name=None, semantic_version=None):  # noqa: E501
        """BdbModuleList - a model defined in Swagger"""  # noqa: E501
        self._module_args = None
        self._module_id = None
        self._module_name = None
        self._semantic_version = None
        self.discriminator = None
        if module_args is not None:
            self.module_args = module_args
        if module_id is not None:
            self.module_id = module_id
        if module_name is not None:
            self.module_name = module_name
        if semantic_version is not None:
            self.semantic_version = semantic_version

    @property
    def module_args(self):
        """Gets the module_args of this BdbModuleList.  # noqa: E501

        Module command line arguments (pattern does not allow special characters &,<,>,\\\")  # noqa: E501

        :return: The module_args of this BdbModuleList.  # noqa: E501
        :rtype: str
        """
        return self._module_args

    @module_args.setter
    def module_args(self, module_args):
        """Sets the module_args of this BdbModuleList.

        Module command line arguments (pattern does not allow special characters &,<,>,\\\")  # noqa: E501

        :param module_args: The module_args of this BdbModuleList.  # noqa: E501
        :type: str
        """

        self._module_args = module_args

    @property
    def module_id(self):
        """Gets the module_id of this BdbModuleList.  # noqa: E501

        Module UID  # noqa: E501

        :return: The module_id of this BdbModuleList.  # noqa: E501
        :rtype: str
        """
        return self._module_id

    @module_id.setter
    def module_id(self, module_id):
        """Sets the module_id of this BdbModuleList.

        Module UID  # noqa: E501

        :param module_id: The module_id of this BdbModuleList.  # noqa: E501
        :type: str
        """

        self._module_id = module_id

    @property
    def module_name(self):
        """Gets the module_name of this BdbModuleList.  # noqa: E501

        Module's name  # noqa: E501

        :return: The module_name of this BdbModuleList.  # noqa: E501
        :rtype: str
        """
        return self._module_name

    @module_name.setter
    def module_name(self, module_name):
        """Sets the module_name of this BdbModuleList.

        Module's name  # noqa: E501

        :param module_name: The module_name of this BdbModuleList.  # noqa: E501
        :type: str
        """

        self._module_name = module_name

    @property
    def semantic_version(self):
        """Gets the semantic_version of this BdbModuleList.  # noqa: E501

        Module's semantic version  # noqa: E501

        :return: The semantic_version of this BdbModuleList.  # noqa: E501
        :rtype: str
        """
        return self._semantic_version

    @semantic_version.setter
    def semantic_version(self, semantic_version):
        """Sets the semantic_version of this BdbModuleList.

        Module's semantic version  # noqa: E501

        :param semantic_version: The semantic_version of this BdbModuleList.  # noqa: E501
        :type: str
        """

        self._semantic_version = semantic_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BdbModuleList, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BdbModuleList):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
